package Stage3D;
import DataPack.*;
import javax.vecmath.*;

public class ActSetAngle extends Acting
{
	private Actor target;
	private Vector3d point;
	private Vector3d dir;
	private Vector3d r = new Vector3d();
	private double Speed;
	private boolean lock;
	private boolean latiFlag,longFlag;
	private int mode;
	public boolean setOption(DataPack[] datapacks)
	{
		double x,y,z;
		setIsActive(false);
		//if(datapacks.length<1) return false;
		DataPack datapack = datapacks[0];
		int[] id = datapack.getIntData();
		double[] dd = datapack.getDoubleData();
		String[] sd = datapack.getStringData();
		//DataPack[] dpd = datapack.getDataPack();

		if (id.length < 1)
			return false;
		if (id[0]==0)  //Actor⡼
		{
			if (sd.length < 1)
				return false;
			target=getStage().getActor(sd[0]);
			if (target==null) return false;
			mode = 0;
		}else if (id[0]==1){  //⡼
			if (dd.length<3)
				return false;
			x=dd[0];
			y=dd[1];
			z=dd[2];
			point = new Vector3d(x,y,z);
			mode = 1;
		}else if (id[0]==2){  //ꤵ줿٥ȥ⡼
			if (dd.length<3)
				return false;
			x=dd[0];
			y=dd[1];
			z=dd[2];
			dir = new Vector3d(x,y,z);
			mode = 2;
		}else if (id[0]==3){  //ꤵ줿٤⡼
			if (dd.length<2)
				return false;
			r.x=dd[0];
			r.y=dd[1];
			mode = 3;
		}else if (id[0]==4){  //ꤵ줿٤⡼ɡlongitudeΤߡ
			if (dd.length<1)
				return false;
			r.y=dd[0];
			mode = 4;
		}else if (id[0]==5){  //ꤵ줿٤⡼ɡlatitudeΤߡ
			if (dd.length<1)
				return false;
			r.x=dd[0];
			mode = 5;
		}else{
			return false;
		}
		setIsActive(true);
		return true;

	}

	public boolean doActing()
	{
		if (getInterruptedFlag()!=0)
		{
			setIsActive(false);
			return false;
		}
		//if (event!=null) {getStage().throwEvent(event); event = null;}
		double t;
		double radt;
		Vector3d r2;
		r2 = getTargetActor().getAngle();
		if (mode==0){
			dir = target.getPosition();
			dir.sub(getTargetActor().getPosition());
			r = getStage().getAngle(dir);
		}else if (mode==1){
			dir = new Vector3d(point);
			dir.sub(getTargetActor().getPosition());
			r = getStage().getAngle(dir);
		}else if (mode==2){
			r = getStage().getAngle(dir);
			//}else if (mode==3){
		}else if (mode==4){
			r.x=r2.x;
		}else if (mode==5){
			r.y=r2.y;
		}

		getTargetActor().setAngle(r);
		setIsActive(false);
		return false;
	}
	public void interrupted(int signal)
	{
		if (signal!=0) setIsActive(false);
	}
}
