package Stage3D.utils;
import Stage3D.*;
import DataPack.*;

public class ActCamSetCamMode extends SimpleCamActing
{
	private int mode;

	public boolean setOption(DataPack[] datapacks)
	{
		setIsActive(false);
		//if(datapacks.length<1) return false;
		DataPack datapack = datapacks[0];
		int[] id = datapack.getIntData();

		if (id.length<1)
			return false;
        mode = id[0];
		setIsActive(true);
		return true;
	}
	public boolean doActing()
	{
		if (getInterruptedFlag()!=0)
		{
			setIsActive(false);
			return false;
		}
		getTargetCamera().setCameraMode(mode);
		setIsActive(false);
		return false;
	}
	public void interrupted(int signal)
	{
		if (signal!=0) setIsActive(false);
	}
}
