package Stage3D.utils;
import Stage3D.*;
import javax.vecmath.*;
import DataPack.*;

public class ActCamSetCamViewPoint extends SimpleCamActing
{
	private Vector3d position;//δˤʤо
	public boolean setOption(DataPack[] datapacks)
	{
		setIsActive(false);
		if(datapacks.length<1) return false;
		DataPack datapack = datapacks[0];
		double[] dd = datapack.getDoubleData();
		double x,y,z;
		if (dd.length<3)
			return false;

		x=dd[0];
		y=dd[1];
		z=dd[2];
		position=new Vector3d(x,y,z);

		setIsActive(true);
		return true;
	}
	public boolean doActing()
	{
		if (getInterruptedFlag()!=0)
		{
			setIsActive(false);
			return false;
		}
		getTargetCamera().setCamViewPoint(position);
		setIsActive(false);
		return false;
	}
	public void interrupted(int signal)
	{
		if (signal!=0) setIsActive(false);
	}
}
